#ifndef _STACK_H_
#define _STACK_H_

#include "common.h"

#if STACK == 1

struct _stack_node
{
	void * obj;
	struct _stack_node * next;
};

struct _stack
{
	struct _stack_node * _head;
	uint32_t _capacity;			//  for array
	uint32_t _ratio;			// չ for array
	uint32_t _size;				// ջС
	uint32_t _obj_size;			// ԪشС

	// base
	uint32_t(*size)(struct _stack* s);
	bool (*empty)(struct _stack* s);

	// kernel
	bool (*peek)(struct _stack* s, void *obj);
	bool (*push)(struct _stack* s, void* obj);
	bool (*pop)(struct _stack* s, void* obj);

	// others
	bool (*clear)(struct _stack* s);
	void (*destory)(struct _stack* s);
	void (*print_obj)(void* obj);
	void (*print)(struct _stack* s);
};

bool stack_init(struct _stack* s, uint32_t obj_size);	// 
bool stack2_init(struct _stack* s, uint32_t obj_size);	// 

#endif

#endif // _STACK_H_

